(function($, window) {
	var codes = SysCodeList;
	
	var codelisttemp = ["{@each codes as it, index}",
	                  "<option value='${it.valueName}' ",
	                  "{@if (value && value == it.valueName)} selected='selected' {@/if}>",
	                  "${it.valueLabel}</option>{@/each}"].join("");
	
	//转换代码值
	var getCodeList = function(value, name) {
		var codeLable = "";
		if (!value) {
			codeLable = "";
		} else if (value == "*") {
			codeLable = "不限";
		} else {
			if(name && codes[name] && codes[name]["codeValue"]) {
				var codeArray = codes[name]["codeValue"];
				for(var i in codeArray) {
					var code = codeArray[i];
					if(value == code["valueName"]) {
						return code["valueLabel"];
					}
				}
				codeLable = "无";
			}else {
				codeLable = "无";
			}
		}
		return codeLable;
	}
	
	//返回select的option
	var getCodeListArray = function(name, value, isEmpty) {
		var ops = "";
		var empty = "<optin>无</option>";
		value = value || false;
		if(name && codes[name] && codes[name]["codeValue"]) {
			if(isEmpty) ops += "<option value=''>请选择</option>";
			var codeArray = codes[name]["codeValue"];
			ops += $.template(codelisttemp, {codes : codeArray, value : value});
		}else {
			ops = empty;
		}
		return ops;
	}
	
	//select : data-codeselect,data-codeselectval,data-codeselectempty
	var setDataCodeSelect = function() {
		var selects = $.mobile.activePage.find("select[data-codeselect]");
		$.each(selects, function(i, v) {
			var sel = $(v), cn = sel.attr("data-codeselect"), cv = sel.attr("data-codeselectval"), em = sel.attr("data-codeselectempty");
			if(sel.find("option").length == 0) {
				var opt = getCodeListArray(cn, cv, em);
				sel.html(opt).trigger("change");
			}
		})
	}
	
	//span,lable,div,h1,h2,p : data-codeselect,data-codeselectval
	var setDataCodeValue = function() {
		var selects = $.mobile.activePage.find("span,lable,div,h1,h2,p").filter("[data-codeselect]");
		$.each(selects, function(i, v) {
			var sel = $(v), cn = sel.attr("data-codeselect"), cv = sel.attr("data-codeselectval");
			var t = getCodeList(cv, cn);
			sel.text(sel.text() + t);
		})
	} 
	
	var CodeUtil = {};
	
	CodeUtil.getCodeList = getCodeList;
	CodeUtil.getCodeListArray = getCodeListArray;
	
	CodeUtil.setDataCodeSelect = setDataCodeSelect;
	CodeUtil.setDataCodeValue = setDataCodeValue;
	
	$.template.register('CodeList', getCodeList);
	$.template.register('CodeListArray', getCodeListArray);
	
	window.CodeUtil = CodeUtil;
}(jQuery, window))