/**
 * @author zhangsk 2008年3月25日 v 1.0
 */
function Pid(num){
    this.num = num;
	if(num.indexOf("_")>=0){
		this.num = this.num.replaceAll("_","");
	}
    this._city = {
        11: "北京",
        12: "天津",
        13: "河北",
        14: "山西",
        15: "内蒙古",
        21: "辽宁",
        22: "吉林",
        23: "黑龙江",
        31: "上海",
        32: "江苏",
        33: "浙江",
        34: "安徽",
        35: "福建",
        36: "江西",
        37: "山东",
        41: "河南",
        42: "湖北",
        43: "湖南",
        44: "广东",
        45: "广西",
        46: "海南",
        50: "重庆",
        51: "四川",
        52: "贵州",
        53: "云南",
        54: "西藏",
        61: "陕西",
        62: "甘肃",
        63: "青海",
        64: "宁夏",
        65: "新疆",
        71: "台湾",
        81: "香港",
        82: "澳门",
        91: "国外"
    }
    this._reLenght = new RegExp(/(^\d{15}$)|(^\d{17}([0-9]|X)$)/);
    this._reCard15 = new RegExp(/^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/);
    this._reCard18 = new RegExp(/^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/);
	this.check=this._checkIdCardNo;
	this.getBirthDay=this._getBirthDay;
	this.getBirthDay1=this._getBirthDay1;
	this.getGender=this._getGender;
	this.getGenderCode=this._getGenderCode;
	this.getCity=this._getCity;
	return this;
}


//这个可以验证15位和18位的身份证，并且包含生日和校验位的验证。
Pid.prototype._checkIdCardNo = function(){
    var num = this.num;
    num = num.toUpperCase();
    if(!this._reLenght.test(num)) return "格式不正确！";
    var reStr = "";
	
    //身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X。   
    if (!(/(^\d{15}$)|(^\d{17}([0-9]|X)$)/.test(num))) {
        reStr = reStr + "输入的身份证号:\"" + num + "\"长度不对，或者号码不符合规定！\n15位号码应全为数字，18位号码末位可以为数字或X。";
    }
    //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。 
    //下面分别分析出生日期和校验位
    var len, re;
    len = num.length;
    if (len == 15) {
        var arrSplit = num.match(this._reCard15);
        
        //检查生日日期是否正确 
        var dtmBirth = new Date('19' + arrSplit[2] + '/' + arrSplit[3] + '/' + arrSplit[4]);
        var bGoodDay;
        bGoodDay = (dtmBirth.getYear() == Number(arrSplit[2])) && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3])) && (dtmBirth.getDate() == Number(arrSplit[4]));
        if (!bGoodDay) {
            reStr = reStr + "输入的身份证号里出生日期不对！" + "\n";
        }
        else {
            //将15位身份证转成18位 
            //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。 
            var num_ = this.upgradeIdcard(num);
            //reStr = reStr + "您输入的是15位身份证号码:\"" + num + "\"转换位18位后是：" + num_;
            return true;
        }
    }
    if (len == 18) {
        var arrSplit = num.match(this._reCard18);
        
        //检查生日日期是否正确 
        var dtmBirth = new Date(arrSplit[2] + "/" + arrSplit[3] + "/" + arrSplit[4]);
        var bGoodDay;
        bGoodDay = (dtmBirth.getFullYear() == Number(arrSplit[2])) && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3])) && (dtmBirth.getDate() == Number(arrSplit[4]));
        if (!bGoodDay) {
            //alert(dtmBirth.getYear());
            //alert(arrSplit[2]);
            reStr = reStr + "您输入的身份证号里出生日期不对！" + "\n";
        }
        else {
            //检验18位身份证的校验码是否正确。 
            //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。 
            var valnum;
            var arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
            var arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
            var nTemp = 0, i;
            for (i = 0; i < 17; i++) {
                nTemp += num.substr(i, 1) * arrInt[i];
            }
            valnum = arrCh[nTemp % 11];
            if (valnum != num.substr(17, 1)) {
                reStr = reStr + "您输入身份证号码的第18位校验码不正确！应该为：" + valnum + "\n";
                return reStr;
            }
            reStr = true;
        }
    }
    return reStr;
}
//15位身份证转18位身份证算法
//此方法没有对身份证的有效性进行校验，开发调用时需要慎重使用
Pid.prototype.upgradeIdcard = function(){
    var num = this.num;
    if (num.length == 18) //如果是18位返回原值
        return num;
    if(num.length!=15)//如果不是15位返回原值
    	return num;    	
    if(!(/^(0|[1-9][0-9]*)$/).test(num))//如果不是数据返回原值
    	return num;
    var num_ = num.substr(0, 6) + '19' + num.substr(6, num.length - 6);
    var arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
    var arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
    var nTemp = 0, i;
    for (i = 0; i < 17; i++) {
        nTemp += parseInt(num_.substr(i, 1)) * parseInt(arrInt[i]);
    }
    num_ += arrCh[nTemp % 11];
    return num_;
}

Pid.prototype._getBirthDay1 = function(){
	var a = this._getBirthDay();
	if(a.indexOf("!")>0)
		return "";
	return a;
}

//从身份证中提取出生日期（兼容15位和18位身份证）
Pid.prototype._getBirthDay = function(){
	var num = this.num;
    num = num.toUpperCase();
	if(num==""||num==null) return "";
    var reStr = "";
    var len, re;
    len = num.length;
    if (!(/(^\d{15}$)|(^\d{17}([0-9]|X)$)/.test(num))) {
        return "输入的身份证号:\"" + num + "\"长度不对，或者号码不符合规定！\n15位号码应全为数字，18位号码末位可以为数字或X。";
    }
    //如果是15位身份证则调用upgradeIdcard函数升到18位身份证
    if (len == 15) {
        num = this.upgradeIdcard(num);
    }
    
    var arrSplit = num.match(this._reCard18);
    //检查生日日期是否正确 
    var dtmBirth = new Date(arrSplit[2] + "/" + arrSplit[3] + "/" + arrSplit[4]);
    sBirthday = num.substr(6, 4) + "-" + num.substr(10, 2) + "-" + num.substr(12, 2);
    var bGoodDay;
    bGoodDay = (dtmBirth.getFullYear() == Number(arrSplit[2])) && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3])) && (dtmBirth.getDate() == Number(arrSplit[4]));
    if (!bGoodDay) {
        //alert(dtmBirth.getYear());
        //alert(arrSplit[2]);
        reStr = reStr + "您输入的身份证号里出生日期不对！" + "\n";
    }
    else {
        reStr = sBirthday;
    }
    return reStr;
}
//根据身份证号码获得性别（兼容15位，18位身份证）
Pid.prototype._getGender = function(){
	var num = this.num;
    num = num.toUpperCase();
	if(num==""||num==null) return "";
    var len, re;
    len = num.length;
    if (!(/(^\d{15}$)|(^\d{17}([0-9]|X)$)/.test(num))) {
        return "输入的身份证号:\"" + num + "\"长度不对，或者号码不符合规定！\n15位号码应全为数字，18位号码末位可以为数字或X。";
    }
    //如果是15位身份证则调用upgradeIdcard函数升到18位身份证
    if (len == 15) {
        num = this.upgradeIdcard(num);
    }
    return num.substr(16, 1) % 2 ? "1" : "2";
}
//根据身份证号码获得性别（兼容15位，18位身份证）
Pid.prototype._getGenderCode = function(){
	var num = this.num;
    num = num.toUpperCase();
	if(num==""||num==null) return "";
    var len, re;
    len = num.length;
    if (!(/(^\d{15}$)|(^\d{17}([0-9]|X)$)/.test(num))) {
        return "输入的身份证号:\"" + num + "\"长度不对，或者号码不符合规定！\n15位号码应全为数字，18位号码末位可以为数字或X。";
    }
    //如果是15位身份证则调用upgradeIdcard函数升到18位身份证
    if (len == 15) {
        num = this.upgradeIdcard(num);
    }
    return num.substr(16, 1) % 2?1:2;
}

//根据18位身份证号码获得性别
Pid.prototype._getCity=function(){
	var num = this.num;
    num = num.toUpperCase();
	if(num==""||num==null) return "";
	return this._city[parseInt(num.substr(0, 2))];
}
