(function($, window) {
	AgileUtil = {
		notice :  $.maf['native'] ? $.maf['native'].notification : null,
		datepicker : $.maf['native'] ? $.maf['native'].datepicker : null,
		alert : function(message, alertCallback, title, buttonName) {
			if (title == undefined) {
				title = "提示信息";
			}
			if (buttonName == undefined) {
				buttonName = "确定";
			}
			if (alertCallback == undefined || alertCallback == "") {
				alertCallback = undefined;
			}
			if (this.notice == undefined) {
				alert(message);
				if (alertCallback != undefined) {
					alertCallback();
				}
			} else {
				this.notice.alert(message, alertCallback, title, buttonName);
			}
		},
		confirm : function(message, alertCallback, title, buttonName) {
			if (title == undefined || title == "") {
				title = "提示信息";
			}
			if (buttonName == undefined || buttonName == "") {
				buttonName = "确定,取消";
			}
			if (alertCallback == undefined || alertCallback == "") {
				alertCallback = undefined;
			}
			if (this.notice == undefined) {
				if (confirm(message)) {
					if (alertCallback != undefined) {
						alertCallback(1);
					}
				}
			} else {
				this.notice.confirm(message, alertCallback, title, buttonName);
			}
		},
		showToast : function(message, duration, position) {
			if (duration == undefined || duration == "") {
				duration = 0;
			}
			if (position == undefined || position == "") {
				position = 1;
			}
			if (this.notice == undefined) {
				alert(message);
			} else {
				this.notice.showToast(message, duration, position);
			}
		},
		ajax : function(url, data, callback, errorback, showLoading) {
			// 判断当前设备是否已经连接网络
			/*
			var connect = $.maf['native'].connection.getConnection();
			if (connect == "NONE") {// 当未连接网络的时候，弹出提示框，是否进行网络配置
				this.confirm("您当前未连接网络，是否进行网络配置？", function(value) {
					if (value == "1") {
						// 打开设备的网络设置页面
						$.maf['native'].connection.configNetwork();
					}
				}, "提示信息", "确定,取消");
				return false;
			} else if (connect == "2G") {
				this.showToast("当前连接的网络为2G低速网，可能会影响您的使用体验，请谅解");
			}
 			*/
			if (url.indexOf("?") >= 0) {
				url = url + "&ts=" + (new Date()).getTime();
			} else {
				url = url + "?ts=" + (new Date()).getTime();
			}
			if (showLoading == undefined || showLoading == "") {
				showLoading = true;
			}
			var pagea = $.mobile.activePage.attr("id");
			var param = {
				url : url,
				dataType : "json",
				load : function(result) {
					var pageb = $.mobile.activePage.attr("id");
					if(pagea != pageb) return;
					
					if (!(result instanceof Object)) {
						result = eval("(" + result + ")");
					}
					if (result.hasError) {
						if (result.errors) {
							var errors = result.errors.message;
							var msg = [];
							if (errors instanceof Object) {
								for ( var i in errors) {
									if (errors[i] instanceof Array) {
										for ( var j = 0; j < errors[i].length; j++) {
											msg.push(errors[i][j]);
										}
									} else {
										msg.push(errors[i]);
									}
								}
							} else if (errors instanceof Array) {
								for ( var i = 0; i < errors.length; i++) {
									msg.push(errors[i]);
								}
							} else {
								msg.push(errors);
							}
							AgileUtil.alert(msg.join("<br/>"));
						}
						if (errorback) {
							errorback(result);
						} else if (callback) {
							callback(result);
						}
					} else {
						if (callback) {
							callback(result);
						}
					}
				},
				error : function(a, b, c) {
					if (a.status == 500) {
						AgileUtil.showToast("系统发生内部错误，请稍后再试");
						return;
					}
					if (a.status == 403) {
						try {
							var m = a.responseText;
							m = eval("(" + m + ")");
							AgileUtil.alert("您还没有登录，或者登录超时，请重新登录", function() {
								window.location.href = m["goto"];
							}, "系统提示");
						} catch (e) {
							AgileUtil.showToast("系您未授权访问此资源");
						}
						return;
					}
					if (a.status == 404) {
						AgileUtil.showToast("系统访问路径错误");
						return;
					}
					AgileUtil.showToast("当前系统无法连接服务器，请检查你的网络设置，稍后重试");
				},
				method : "post",
				sync : true
			}
			//$.maf.action.requestData(param, data, showLoading);
			/*
			this.getAppUser(function(userdata) {
				if(userdata) {
					var idno = userdata.idno;
					$.extend(data, {idno : idno});
				}
				$.maf.action.requestData(param, data, showLoading);
			})
			*/
		},
		//ajax请求方法：增加若请求未完成，按返回时停止请求
		requestData : function(url, data, success, error, showLoading) {
			isShowingLoading = false;
			var req = $.ajax({
				url : url,
				data : data,
				type : "POST",
				timeout : 30 * 1000,
				async : true,
				beforeSend : function() {
					if (showLoading !== false) {
						isShowingLoading = true;
						isShowingLoading && $.maf.showLoading();
					}
				},
				cache : false,
				dataType : "json",
				context : document.body,
				success : function(result, textStatus, jqXHR) {
					if (result.hasError && result.errors) {
						var errors = result.errors.message;
						var msg = [];
						if (errors instanceof Object) {
							for ( var i in errors) {
								if (errors[i] instanceof Array) {
									for ( var j = 0; j < errors[i].length; j++) {
										msg.push(errors[i][j]);
									}
								} else {
									msg.push(errors[i]);
								}
							}
						} else if (errors instanceof Array) {
							for ( var i = 0; i < errors.length; i++) {
								msg.push(errors[i]);
							}
						} else {
							msg.push(errors);
						}
						AgileUtil.showToast(msg.join(";"));
					} else {
						success && success(result, textStatus, jqXHR);
					}
				},
				error : function(jqXHR, textStatus, errorThrown) {
					var status = jqXHR.status;
					var errorMsg = "";
					switch (status) {
					case 500:
						errorMsg = "系统发生内部错误，请稍后再试！";
						break;
					case 404:
						errorMsg = "请求路径错误！";
						break;
					case 403:
						errorMsg = "系您未授权访问此资源！";
						break;
					default:
						errorMsg = "服务器发生错误，请稍后尝试！";
					}
					AgileUtil.showToast(errorMsg);
					error && error(jqXHR, textStatus, errorThrown);
				},
				complete : function(jqXHR, textStatus) {
					delete window.AGILE_AJAX;
					isShowingLoading && $.maf.hideLoading();
				}
			});
			window.AGILE_AJAX = req;
		},
		validLoginStatus : function() {
			var loginstatus = window.sessionStorage.getItem("loginstatus");
			if (loginstatus != "1") {
				this.confirm("您当前还没有登录,不能使用该功能，请您先登录系统。", function(btn) {
					if(btn == 1) {
						$.mobile.changePage("login.html", {});
					}
				})
				/*this.alert("您当前还没有登录,不能使用该功能，请您先登录系统。", function() {
					$.mobile.changePage("login.html", {});
				}, "系统提示");*/
				return false;
			}
			return true;
		},
		showDate : function(success, error) {
			var c = function(str) {
				return str < 10 ? "0" + str : str
			}
			if (this.datepicker) {
				this.datepicker.showDate(function(d) {
					var v = d.year + "-" + c(d.month + 1) + "-" + c(d.day);
					success && success(v);
				}, function() {
					error && error();
				})
			}
		},
		showTime : function(success, error) {
			if (this.datepicker) {
				this.datepicker.showDate(function(d) {
					var v = (d.hour + 1) + ":" + (d.minute + 1);
					success && success(v);
				}, function() {
					error && error();
				})
			}
		},
		loadCodeData : function(type, callback, content, showLoading) {
			var key = "";
			switch (type) {
			case 2:
				key = "SysMenu"; // 程序菜单项
				break;
			case 6:
				key = "SysNewsContents"; // cms文章菜单项
				break;
			default:
				type = 2;
				key = "SysMenu";
			}
			if (!window[key]) {
				var codestring = localStorage.getItem(key);
				if (codestring) {
					eval(codestring);
					callback && content && callback.call(content);
				} else {
					AgileUtil.requestData(AJAX_URL + "z/a/itdcode.js?itdtype=" + type, {}, function(data) {
						var code = data.codedata;
						var windcode = "window." + $.trim(code.substring(code.indexOf("var") + 3));
						eval(windcode);
						localStorage.setItem(key, windcode);
						callback && content && callback.call(content);
					}, null, showLoading);
				}
			} else {
				callback && content && callback.call(content);
			}
			;
		},
		formVal : function(form, others) {
			var form = $(form),
				array = form.serializeArray(),
				j = array.length;
			var vals = {};
			for ( var i = 0; i < j; i++) {
				vals[array[i].name] = array[i].value;
			}
			if (others) {
				for ( var i in others) {
					vals[i] = others[i];
				}
			}
			return vals;
		},
		validForm : function(selecter) {
			var form = $(selecter), 
				elements = form.find("input,select,textarea");
			var hasError = false;
			for(var i = 0, len = elements.length; i < len; i++) {
				var element = elements[i], $element = $(element);
				if(!element.checkValidity()) {
					hasError = true;
					$element.data("oldborder", $element.css("border")).css("border", "1px solid #CE5C5C");
					AgileUtil.showToast(element.dataset.errormsg || element.placeholder || (element.name + ":表单错误，请检查表单项！"), 0, 1);
					return hasError;
				}else {
					$element.data("oldborder") ? $element.css("border", $element.data("oldborder")) : "";
				}
			}
			return hasError;
		},
		getmaf : function(callback) {
			cordova.exec(function(userinfo) {
				var o = JSON.parse(userinfo);
				callback(o)
			}, function() {
				callback(null);
			}, "SIM_AdrToMaf", "user", []);
		},
		getAdr : function(str){
			cordova.exec( null, null,  "MAF_MafToAdr", "showToast", [ str, 0, 0 ] );
			}
	};
	window.AgileUtil = AgileUtil;
}(jQuery, window))